/***
*
*     Date.prg
*
*     ਬ 짮⥫᪨ 㭪権  権  ⠬
*     Copyright, Nantucket Corporation, 1990
*
*   ஢  ﬨ /n/w/a/m
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


#include "Set.ch"



/***
*  Mdy( <dDate> ) --> cDate
*  ८ࠧ   ப  ଠ⮬ <> , .
*
*/
FUNCTION Mdy( dDate )
   LOCAL cYear
   //
   // ࠢ ० SET CENTURY
   IF SUBSTR(SET(_SET_DATEFORMAT), -4) = "YYYY"
      cYear := STR(YEAR(dDate))
   ELSE
      cYear := " " + SUBSTR(STR(YEAR(dDate)), 4, 2)
   ENDIF
   //
   RETURN CMONTH(dDate) + " " + LTRIM(STR(DAY(dDate))) + "," + cYear



/***
*  Dmy( <dDate> ) --> cDate
*  ८ࠧ   ப  ଠ⮬  <> .
*
*/
FUNCTION Dmy( dDate )
   LOCAL cYear
   //
   // ࠢ ० SET CENTURY
   IF SUBSTR(SET(_SET_DATEFORMAT), -4) = "YYYY"
      cYear := STR(YEAR(dDate))
   ELSE
      cYear := " " + SUBSTR(STR(YEAR(dDate)), 4, 2)
   ENDIF
   //
   RETURN LTRIM(STR(DAY(dDate))) + " " + CMONTH(dDate) + cYear



/***
*  DateAsAge( <dDate> ) --> nAge
*  ८ࠧ  ஦  ⢮ 
*
*/
FUNCTION DateAsAge( dDate )
   LOCAL nAge := 0
   //
   IF YEAR(DATE()) > YEAR(dDate)
      nAge := YEAR(DATE()) - YEAR(dDate)
      IF MONTH(DATE()) < MONTH(dDate) .OR.;
         ( MONTH(DATE()) = MONTH(dDate) .AND. DAY(DATE()) < DAY(dDate) )

         --nAge

      ENDIF
   ENDIF
   //
   RETURN nAge



/***
*  AddMonth( <dDate>, <nMonths> ) --> dNewDate
*  ᫥   ⥬ ਡ  ⢠
*  楢   
*
*/
FUNCTION AddMonth( dDate, nMonths)
   LOCAL nMonth, nDay, nYear, nLimit, nMonthAdd, nYearAdd, dNew

   // ᫮  
   nMonth := MONTH( dDate )
   nDay   := DAY( dDate )
   nYear  := YEAR( dDate )

   // nLimit । 쭮 ⢮ 楢, ।饥
   //   ᫥騩 .  ᫨ ⢮ 塞 楢 ॢ蠥
   //  稭,    㢥祭
   nLimit := 12 - nMonth + 1

   // ᫥ ⢠ 塞 
   nYearAdd := INT( nMonths / 12 )
   IF nMonths >= nLimit
      nYearAdd++
   ENDIF
   nYear += nYearAdd

   // ᫥ ⢠ 塞 楢  ଠ 祭 ᫠
   nMonthAdd := nMonths % 12
   nMonth := (nMonth + nMonthAdd) % 12

   // ८ࠧ ᫮ ⥩   
   dNew := CTOD(STR(nMonth, 2) + "/" + STR(nDay, 2) + "/" + STR(nYear, 4))

   RETURN (dNew)


/***
*  DateAsArray( dDate ) --> aDate
*  ८ࠧ   ᨢ ,   
*
*/
FUNCTION DateAsArray( dDate )
   LOCAL aDate := {}
   IF VALTYPE( dDate ) != "D"
      // :  ⨯ 㬥
      RETURN (aDate)
   ELSE
      aDate := { YEAR( dDate ), MONTH( dDate ), DAY( dDate ) }
   ENDIF

   RETURN aDate


/***
*  ArrayAsDate( aDate ) --> dDate
*  ८ࠧ ᨢ ,     
*
*/
FUNCTION ArrayAsDate( aDate )
   RETURN CTOD(STR(aDate[2], 2) + "/" + STR(aDate[3], 2) + "/" + STR(aDate[1], 4))


/***
*  DateIsLeap( <dDate> ) --> lLeap
*  ।,      ᮪
*
*/
FUNCTION DateIsleap( dDate )
   LOCAL nYear := YEAR(dDate)
   RETURN ((nYear % 4) == 0) .AND. ;
          (((nYear % 100) != 0) .OR. ((nYear % 400) == 0))