/***
*  Stack.prg
*  㭪樨  ॠ樨 ⥪ 堭
*  Copyright (c) 1990 Nantucket Corp.   ࠢ ࠭.
*
*  ஢  ﬨ: /n/w/a/m
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


/***
*     ⠪ ⥪?
*
*     ⥪ -   ࠭    Last-In-First-Out
*     (LIFO) - "᫥ 襫 -  襫".   ⢥ 
*      ᬮ ⥪ . ᫨    A  ⮫,
*       -  B,  ᢥ  C, , ⠪ ࠧ,  ᮧ
*     ⥪   ⮢.  C 㤥 室  設
*     ⥪,   A -  ⥪.
*
*         ⥪ 뢠 "⠫"
*     (pushing)   ⥪.  ࠧ,  "⮫㫨" 
*       ⥪ .    設 ⥪
*     뢠 "⠫" (popping) .  ⫨稥 
*      ⥪,       ।
*     ⥪  , 㤠  "⠫" 
*     ⭮ 浪.   , ᫥  ⠥ 
*     (LIFO).
*
*     ᯮ 㭪樨 ⮣ 䠩,   ஢ ⥪ 
*     ⠪,    :
*
*    //  ⮩ ⥪
*    aStack := StackNew()
*
*    //     ⥪
*    StackPush( aStack, " A" )
*    StackPush( aStack, " B" )
*    StackPush( aStack, " C" )
*
*    //  "⮫"
*    ? StackPop( aStack )      // 뢮 " C"
*    ? StackPop( aStack )      // 뢮 " B"
*    ? StackPop( aStack )      // 뢮 " A" (⥯ ⥪ )
*
*
*    㣨 ਬ஬   ⥪ ⠭ 梥:
*
*    aColors := StackNew()
*
*    StackPush( aColors, SETCOLOR() )  // ࠭ ⥪ ⠭
*    SETCOLOR( .... )                  //  ⠭
*    ....                              // 맮 㣨 㭪権, 믮
*                                      // -
*
*    SETCOLOR( StackPop( aColors ) )   // ⠭  ⭮ 浪
*
*/


/***
*  㭪樨:
*
*    StackNew() --> aStack
*      ⥪
*
*    StackPush( <aStack>, <exp> ) --> aStack
*       ⥪
*
*    StackPop( <aStack> ) --> value
*       ⥪     NIL, ᫨ ⥪ 
*
*    StackIsEmpty( <aStack> ) --> lEmpty
*    ஢ઠ  ⥪
*
*    StackTop( <aStack> ) --> value
*    뤠 祭   設 ⥪   
*
*/


/***
*   StackNew() --> aStack
*     ⥪
*/
FUNCTION StackNew()
   RETURN {}


/***
*   StackPush( <aStack>, <exp> ) --> aStack
*      ⥪
*/
FUNCTION StackPush( aStack, exp )
   //     ᨢ    ᨢ
   RETURN AADD( aStack, exp )


/***
*   StackPop( <aStack> ) --> value
*      ⥪     NIL, ᫨ ⥪ 
*
*/
FUNCTION StackPop( aStack )
   LOCAL valueLast, nLen := LEN( aStack )

   // ஢ઠ  
   IF nLen == 0
      RETURN NIL
   ENDIF

   // 祭 ᫥  ᨢ, 饣 ⮬ 設 ⥪
   valueLast := aStack[ nLen ]

   // 㤠 ᫥  ⥬ 㪮祭 ᨢ
   ASIZE( aStack, nLen - 1 )

   //  뤥 祭
   RETURN valueLast


/***
*  StackIsEmpty( <aStack> ) --> lEmpty
*   ஢ઠ  ⥪
*
*/
FUNCTION StackIsEmpty( aStack )
   RETURN EMPTY( aStack )


/***
*  StackGetTop( <aStack> ) --> value
*   뤠 祭   設 ⥪   
*
*/
FUNCTION StackGetTop( aStack )
   //
   //  ᫥  ᨢ, 饣 ⮬ 設 ⥪
   RETURN ATAIL( aStack )


/***
*  StackTop( <aStack> ) --> value
*  뤠 祭   設 ⥪   
*
*/
FUNCTION StackTop( aStack )
   //
   //  ᫥  ᨢ, 饣 ⮬ 設 ⥪
   RETURN ATAIL( aStack )